
#pragma once

#include "libpq-fe.h"
namespace pqtypesimport
{
#include "libpqtypes.h"
#include <libpqtypes-int.h>
}

typedef int PGbool;
typedef short PGint2;
typedef unsigned short PGUint2;
typedef int PGint4;
typedef unsigned int PGUint4;
typedef __int64 PGint8;
typedef unsigned __int64 PGUint8;
typedef float PGfloat4;
typedef double PGfloat8;
typedef std::string PGvarchar;

using pqtypesimport::PGdate;
using pqtypesimport::PGtimestamp;
using pqtypesimport::PGinterval;
using pqtypesimport::PGmacaddr;
using pqtypesimport::PGinet;
using pqtypesimport::PGarray;
using pqtypesimport::PGparam;
class PGbytea 
{
	size_t  size;
    char *data;
public:
        PGbytea(const size_t pSize,const char *pData)
                        : size(0),data(0) 
        {
                        if (pData);else return;
                        
                        this->data = new char[pSize];
                        memcpy(this->data,pData,pSize*sizeof(char));
                        this->size = pSize;
        }
        PGbytea(const PGbytea& tocopy):size(0),data(0) 
        {
                        this->data = new char[tocopy.size];
                        ::memcpy(this->data,tocopy.data,tocopy.size*sizeof(char));
                        size = tocopy.size;
        }
        PGbytea():size(0),data(0) {
                        /*-nothing-*/
        }

        ~PGbytea() 
		{
            this->size=0;
            delete[]this->data;
            this->data=0;
        }

        PGbytea &operator=(const PGbytea& right) 
        {
            if (right.size > this->size) 
            {
                delete[]this->data;
                this->data = 0;
                this->data = new char[right.size];
            } 
            ::memcpy(this->data, right.data, right.size * sizeof(char));

            this->size = right.size;
            return*this;
        }

        const size_t getSize() const 
		{
			return this->size;
        }
        const char *getData() const 
		{
			return this->data;
        }
};

//using pqtypesimport::PQparamCreate(const PGconn *conn);


/*typedef boost::numeric::ublas::matrix<PGdate>     PG_date_matrix;
typedef boost::numeric::ublas::matrix<PGtimestamp>PG_timestamp_matrix;
typedef boost::numeric::ublas::matrix<PGmacaddr>  PG_macaddr_matrix;
typedef boost::numeric::ublas::matrix<PGinet>                PG_inet_matrix;*/

