#include <list>

#pragma once
template<class R, size_t C>
struct lt_pred
{
	bool operator()(const boost::shared_ptr<R>&left, const boost::shared_ptr<R>&right)
	{ 
		return *boost::fusion::at<boost::mpl::int_<C>>(*left.get()) < *boost::fusion::at<boost::mpl::int_<C>>(*right.get());
	}
};
template<size_t Cl, class R1, size_t Cr, class R2>
struct cmp_pred
{
	bool eq(const boost::shared_ptr<R1> &left, const boost::shared_ptr<R2> &right)
	{
		return *boost::fusion::at<boost::mpl::int_<Cl>>(*left.get()) == *boost::fusion::at<boost::mpl::int_<Cr>>(*right.get());
	}
	bool lt(const boost::shared_ptr<R1> &left, const boost::shared_ptr<R2> &right)
	{
		return *boost::fusion::at<boost::mpl::int_<Cl>>(*left.get()) < *boost::fusion::at<boost::mpl::int_<Cr>>(*right.get());
	}
	bool gt(const boost::shared_ptr<R1> &left, const boost::shared_ptr<R2> &right)
	{
		return *boost::fusion::at<boost::mpl::int_<Cl>>(*left.get()) > *boost::fusion::at<boost::mpl::int_<Cr>>(*right.get());
	}
};

template<class R, size_t C1, size_t C2>
struct lt_pred2
{
	bool operator()(const boost::shared_ptr<R>&left, const boost::shared_ptr<R>&right)
	{ 
		if (*boost::fusion::at<boost::mpl::int_<C1>>(*left.get()) < *boost::fusion::at<boost::mpl::int_<C1>>(*right.get()))
		{
			return true;
		}
		else
		if (*boost::fusion::at<boost::mpl::int_<C1>>(*left.get()) == *boost::fusion::at<boost::mpl::int_<C1>>(*right.get()))
		{
			return (*boost::fusion::at<boost::mpl::int_<C2>>(*left.get()) < *boost::fusion::at<boost::mpl::int_<C2>>(*right.get()));
		}
		return false;
	}
};
template<size_t Cl1, size_t Cl2, class R1, size_t Cr1, size_t Cr2, class R2>
struct cmp_pred2
{
	bool eq(const boost::shared_ptr<R1> &left, const boost::shared_ptr<R2> &right)
	{
		return *boost::fusion::at<boost::mpl::int_<Cl1>>(*left.get()) == *boost::fusion::at<boost::mpl::int_<Cr1>>(*right.get())
			&& *boost::fusion::at<boost::mpl::int_<Cl2>>(*left.get()) == *boost::fusion::at<boost::mpl::int_<Cr2>>(*right.get());
	}
	bool lt(const boost::shared_ptr<R1> &left, const boost::shared_ptr<R2> &right)
	{
		if (*boost::fusion::at<boost::mpl::int_<Cl1>>(*left.get()) < *boost::fusion::at<boost::mpl::int_<Cr1>>(*right.get()))
		{
			return true;
		}
		else if (*boost::fusion::at<boost::mpl::int_<Cl1>>(*left.get()) == *boost::fusion::at<boost::mpl::int_<Cr1>>(*right.get()))
		{
			return (*boost::fusion::at<boost::mpl::int_<Cl2>>(*left.get()) < *boost::fusion::at<boost::mpl::int_<Cr2>>(*right.get()));
		}
		return false;
	}
	bool gt(const boost::shared_ptr<R1> &left, const boost::shared_ptr<R2> &right)
	{
		if (*boost::fusion::at<boost::mpl::int_<Cl1>>(*left.get()) > *boost::fusion::at<boost::mpl::int_<Cr1>>(*right.get()))
		{
			return true;
		}
		else if (*boost::fusion::at<boost::mpl::int_<Cl1>>(*left.get()) == *boost::fusion::at<boost::mpl::int_<Cr1>>(*right.get()))
		{
			return (*boost::fusion::at<boost::mpl::int_<Cl2>>(*left.get()) > *boost::fusion::at<boost::mpl::int_<Cr2>>(*right.get()));
		}
		return false;
	}
};

template<class R, size_t C1, size_t C2, size_t C3>
struct lt_pred3
{
	bool operator()(const boost::shared_ptr<R>&left, const boost::shared_ptr<R>&right)
	{ 
		if (*boost::fusion::at<boost::mpl::int_<C1>>(*left.get()) < *boost::fusion::at<boost::mpl::int_<C1>>(*right.get()))
		{
			return true;
		}
		else
		if (*boost::fusion::at<boost::mpl::int_<C1>>(*left.get()) == *boost::fusion::at<boost::mpl::int_<C1>>(*right.get()))
		{
			if (*boost::fusion::at<boost::mpl::int_<C2>>(*left.get()) < *boost::fusion::at<boost::mpl::int_<C2>>(*right.get()))
			{
				return true;
			}
			else
			if (*boost::fusion::at<boost::mpl::int_<C2>>(*left.get()) == *boost::fusion::at<boost::mpl::int_<C2>>(*right.get()))
			{
				return (*boost::fusion::at<boost::mpl::int_<C3>>(*left.get()) < *boost::fusion::at<boost::mpl::int_<C3>>(*right.get()));
			}
		}
		return false;
	}
};
template<size_t Cl1, size_t Cl2, size_t Cl3, class R1, size_t Cr1, size_t Cr2, size_t Cr3, class R2>
struct cmp_pred3
{
	bool eq(const boost::shared_ptr<R1> &left, const boost::shared_ptr<R2> &right)
	{
		return *boost::fusion::at<boost::mpl::int_<Cl1>>(*left.get()) == *boost::fusion::at<boost::mpl::int_<Cr1>>(*right.get())
			&& *boost::fusion::at<boost::mpl::int_<Cl2>>(*left.get()) == *boost::fusion::at<boost::mpl::int_<Cr2>>(*right.get())
			&& *boost::fusion::at<boost::mpl::int_<Cl3>>(*left.get()) == *boost::fusion::at<boost::mpl::int_<Cr3>>(*right.get());
	}
	bool lt(const boost::shared_ptr<R1> &left, const boost::shared_ptr<R2> &right)
	{
		if (*boost::fusion::at<boost::mpl::int_<Cl1>>(*left.get()) < *boost::fusion::at<boost::mpl::int_<Cr1>>(*right.get()))
		{
			return true;
		}
		else
		if (*boost::fusion::at<boost::mpl::int_<Cl1>>(*left.get()) == *boost::fusion::at<boost::mpl::int_<Cr1>>(*right.get()))
		{
			if (*boost::fusion::at<boost::mpl::int_<Cl2>>(*left.get()) < *boost::fusion::at<boost::mpl::int_<Cr2>>(*right.get()))
			{
				return true;
			}
			else
			if (*boost::fusion::at<boost::mpl::int_<Cl2>>(*left.get()) == *boost::fusion::at<boost::mpl::int_<Cr2>>(*right.get()))
			{
				return (*boost::fusion::at<boost::mpl::int_<Cl3>>(*left.get()) < *boost::fusion::at<boost::mpl::int_<Cr3>>(*right.get()));
			}
		}
		return false;
	}
	bool gt(const boost::shared_ptr<R1> &left, const boost::shared_ptr<R2> &right)
	{
		if (*boost::fusion::at<boost::mpl::int_<Cl1>>(*left.get()) > *boost::fusion::at<boost::mpl::int_<Cr1>>(*right.get()))
		{
			return true;
		}
		else
		if (*boost::fusion::at<boost::mpl::int_<Cl1>>(*left.get()) == *boost::fusion::at<boost::mpl::int_<Cr1>>(*right.get()))
		{
			if (*boost::fusion::at<boost::mpl::int_<Cl2>>(*left.get()) > *boost::fusion::at<boost::mpl::int_<Cr2>>(*right.get()))
			{
				return true;
			}
			else
			if (*boost::fusion::at<boost::mpl::int_<Cl2>>(*left.get()) == *boost::fusion::at<boost::mpl::int_<Cr2>>(*right.get()))
			{
				return (*boost::fusion::at<boost::mpl::int_<Cl3>>(*left.get()) > *boost::fusion::at<boost::mpl::int_<Cr3>>(*right.get()));
			}
		}
		return false;
	}
};
template<class R, size_t C>
struct gt_pred
{
	bool operator()(const boost::shared_ptr<R>&left, const boost::shared_ptr<R>&right)
	{ 
		return *boost::fusion::at<boost::mpl::int_<C>>(*left.get()) > *boost::fusion::at<boost::mpl::int_<C>>(*right.get());
	}
};
template<class R, size_t C1, size_t C2>
struct gt_pred2
{
	bool operator()(const boost::shared_ptr<R>&left, const boost::shared_ptr<R>&right)
	{ 
		if (*boost::fusion::at<boost::mpl::int_<C1>>(*left.get()) > *boost::fusion::at<boost::mpl::int_<C1>>(*right.get()))
		{
			return true;
		}
		else
			if (*boost::fusion::at<boost::mpl::int_<C1>>(*left.get()) == *boost::fusion::at<boost::mpl::int_<C1>>(*right.get()))
			{
				return (*boost::fusion::at<boost::mpl::int_<C2>>(*left.get()) > *boost::fusion::at<boost::mpl::int_<C2>>(*right.get()));
			}
			return false;
	}
};
template<class R, size_t C1, size_t C2, size_t C3>
struct gt_pred3
{
	bool operator()(const boost::shared_ptr<R>&left, const boost::shared_ptr<R>&right)
	{ 
		if (*boost::fusion::at<boost::mpl::int_<C1>>(*left.get()) > *boost::fusion::at<boost::mpl::int_<C1>>(*right.get()))
		{
			return true;
		}
		else
			if (*boost::fusion::at<boost::mpl::int_<C1>>(*left.get()) == *boost::fusion::at<boost::mpl::int_<C1>>(*right.get()))
			{
				if (*boost::fusion::at<boost::mpl::int_<C2>>(*left.get()) > *boost::fusion::at<boost::mpl::int_<C2>>(*right.get()))
				{
					return true;
				}
				else
					if (*boost::fusion::at<boost::mpl::int_<C2>>(*left.get()) == *boost::fusion::at<boost::mpl::int_<C2>>(*right.get()))
					{
						return (*boost::fusion::at<boost::mpl::int_<C3>>(*left.get()) > *boost::fusion::at<boost::mpl::int_<C3>>(*right.get()));
					}
			}
			return false;
	}
};

template<class T>
struct internal_link_cnt : public std::list<boost::shared_ptr<T> >
{
};
template<class T, class T1>
struct external_link_cnt : public std::list<std::pair<boost::shared_ptr<T>, internal_link_cnt<T1> > >
{
	typedef internal_link_cnt<T1> internal_link_cnt;
	
	template<class T2>
	iterator find(T2 el)
	{
		iterator i = this->begin();
		for(; i != this->end() ; ++i)
		{
			if ((*i).first == el)
			{
				return i;
			}
		}
		return this->end();
	}
};
