#pragma once

inline std::string getStringBetween(const std::string &str, const std::string &from, const std::string &to)
{
	size_t i = str.find(from), j;
	if (i != std::string::npos)
	{
		if ( i + from.length() <= str.length())
		{
			i += from.length();

			if (to.length() == 0)
			{
				return str.substr(i);
			}

			j = str.find(to, i);

			if (j != std::string::npos)
			{
				return str.substr(i, j - i);
			}
		}
	}
	return "";
}

#include <list>

inline std::size_t splitStr(std::list<std::string>& L, const std::string& seq, const std::string& _1cdelim, bool keeptoken, bool _removews )
{

	typedef std::string::size_type ST;
	std::string delims = _1cdelim;
	std::string STR;
	if(delims.empty()) delims = "\n\r";
	if(_removews) delims += " ";

	ST pos=0, LEN = seq.size();
	while(pos < LEN ){
		STR=""; // Init/clear the STR token buffer
		// remove any delimiters including optional (white)spaces
		while( (delims.find(seq[pos]) != std::string::npos) && (pos < LEN) ) ++pos;
		// leave if @eos
		if(pos==LEN) return L.size();
		// Save token data
		while( (delims.find(seq[pos]) == std::string::npos) && (pos < LEN) ) STR += seq[pos++];
		// put valid STR buffer into the supplied list
		//std::cout << "[" << STR << "]";
		if( ! STR.empty() ) L.push_back(STR);
	}
	return L.size();
}